<?php
/**
 * Shams Solar: Customizer
 */

/**
 * Add postMessage support for site title and description for the Theme Customizer.
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */

function shams_solar_customize_register( $wp_customize ) {

	$wp_customize->add_panel( 'shams_solar_panel_id', array(
	    'priority' => 10,
	    'capability' => 'edit_theme_options',
	    'theme_supports' => '',
	    'title' => __( 'Theme Settings', 'shams-solar' ),
	    'description' => __( 'Description of what this panel does.', 'shams-solar' ),
	) );

	// font array
	$font_array = array(
        '' => 'No Fonts',
        'Abril Fatface' => 'Abril Fatface',
        'Acme' => 'Acme',
        'Anton' => 'Anton',
        'Architects Daughter' => 'Architects Daughter',
        'Arimo' => 'Arimo',
        'Arsenal' => 'Arsenal', 
        'Arvo' => 'Arvo',
        'Alegreya' => 'Alegreya',
        'Alfa Slab One' => 'Alfa Slab One',
        'Averia Serif Libre' => 'Averia Serif Libre',
        'Bangers' => 'Bangers', 
        'Boogaloo' => 'Boogaloo',
        'Bad Script' => 'Bad Script',
        'Bitter' => 'Bitter',
        'Bree Serif' => 'Bree Serif',
        'BenchNine' => 'BenchNine', 
        'Cabin' => 'Cabin', 
        'Cardo' => 'Cardo',
        'Courgette' => 'Courgette',
        'Cherry Swash' => 'Cherry Swash',
        'Cormorant Garamond' => 'Cormorant Garamond',
        'Crimson Text' => 'Crimson Text',
        'Cuprum' => 'Cuprum', 
        'Cookie' => 'Cookie', 
        'Chewy' => 'Chewy', 
        'Days One' => 'Days One', 
        'Dosis' => 'Dosis',
        'Droid Sans' => 'Droid Sans',
        'Economica' => 'Economica',
        'Fredoka One' => 'Fredoka One',
        'Fjalla One' => 'Fjalla One',
        'Francois One' => 'Francois One',
        'Frank Ruhl Libre' => 'Frank Ruhl Libre',
        'Gloria Hallelujah' => 'Gloria Hallelujah',
        'Great Vibes' => 'Great Vibes',
        'Handlee' => 'Handlee', 
        'Hammersmith One' => 'Hammersmith One',
        'Inconsolata' => 'Inconsolata', 
        'Indie Flower' => 'Indie Flower', 
        'IM Fell English SC' => 'IM Fell English SC', 
        'Julius Sans One' => 'Julius Sans One',
        'Josefin Slab' => 'Josefin Slab', 
        'Josefin Sans' => 'Josefin Sans', 
        'Kanit' => 'Kanit', 
        'Lobster' => 'Lobster', 
        'Lato' => 'Lato',
        'Lora' => 'Lora', 
        'Libre Baskerville' =>'Libre Baskerville',
        'Lobster Two' => 'Lobster Two',
        'Merriweather' =>'Merriweather', 
        'Monda' => 'Monda',
        'Montserrat' => 'Montserrat',
        'Muli' => 'Muli', 
        'Marck Script' => 'Marck Script',
        'Noto Serif' => 'Noto Serif',
        'Open Sans' => 'Open Sans', 
        'Overpass' => 'Overpass',
        'Overpass Mono' => 'Overpass Mono',
        'Oxygen' => 'Oxygen', 
        'Orbitron' => 'Orbitron', 
        'Patua One' => 'Patua One', 
        'Pacifico' => 'Pacifico',
        'Padauk' => 'Padauk', 
        'Playball' => 'Playball',
        'Playfair Display' => 'Playfair Display', 
        'PT Sans' => 'PT Sans',
        'Philosopher' => 'Philosopher',
        'Permanent Marker' => 'Permanent Marker',
        'Poiret One' => 'Poiret One', 
        'Quicksand' => 'Quicksand', 
        'Quattrocento Sans' => 'Quattrocento Sans', 
        'Raleway' => 'Raleway', 
        'Rubik' => 'Rubik', 
        'Rokkitt' => 'Rokkitt', 
        'Russo One' => 'Russo One', 
        'Righteous' => 'Righteous', 
        'Slabo' => 'Slabo', 
        'Source Sans Pro' => 'Source Sans Pro', 
        'Shadows Into Light Two' =>'Shadows Into Light Two', 
        'Shadows Into Light' => 'Shadows Into Light', 
        'Sacramento' => 'Sacramento', 
        'Shrikhand' => 'Shrikhand', 
        'Tangerine' => 'Tangerine',
        'Ubuntu' => 'Ubuntu', 
        'VT323' => 'VT323', 
        'Varela Round' => 'Varela Round', 
        'Vampiro One' => 'Vampiro One',
        'Vollkorn' => 'Vollkorn',
        'Volkhov' => 'Volkhov', 
        'Yanone Kaffeesatz' => 'Yanone Kaffeesatz',
    );
    
	//Typography
	$wp_customize->add_section( 'shams_solar_typography', array(
    	'title'      => __( 'Color / Fonts Settings', 'shams-solar' ),
		'panel' => 'shams_solar_panel_id'
	) );
	
	// This is Paragraph Color picker setting
	$wp_customize->add_setting( 'shams_solar_paragraph_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_paragraph_color', array(
		'label' => __('Paragraph Color', 'shams-solar'),
		'section' => 'shams_solar_typography',
		'settings' => 'shams_solar_paragraph_color',
	)));

	//This is Paragraph FontFamily picker setting
	$wp_customize->add_setting('shams_solar_paragraph_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control(
	    'shams_solar_paragraph_font_family', array(
	    'section'  => 'shams_solar_typography',
	    'label'    => __( 'Paragraph Fonts','shams-solar'),
	    'type'     => 'select',
	    'choices'  => $font_array,
	));

	$wp_customize->add_setting('shams_solar_paragraph_font_size',array(
		'default'	=> '12px',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_paragraph_font_size',array(
		'label'	=> __('Paragraph Font Size','shams-solar'),
		'section'	=> 'shams_solar_typography',
		'setting'	=> 'shams_solar_paragraph_font_size',
		'type'	=> 'text'
	));

	// This is "a" Tag Color picker setting
	$wp_customize->add_setting( 'shams_solar_atag_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_atag_color', array(
		'label' => __('"a" Tag Color', 'shams-solar'),
		'section' => 'shams_solar_typography',
		'settings' => 'shams_solar_atag_color',
	)));

	//This is "a" Tag FontFamily picker setting
	$wp_customize->add_setting('shams_solar_atag_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control(
	    'shams_solar_atag_font_family', array(
	    'section'  => 'shams_solar_typography',
	    'label'    => __( '"a" Tag Fonts','shams-solar'),
	    'type'     => 'select',
	    'choices'  => $font_array,
	));

	// This is "a" Tag Color picker setting
	$wp_customize->add_setting( 'shams_solar_li_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_li_color', array(
		'label' => __('"li" Tag Color', 'shams-solar'),
		'section' => 'shams_solar_typography',
		'settings' => 'shams_solar_li_color',
	)));

	//This is "li" Tag FontFamily picker setting
	$wp_customize->add_setting('shams_solar_li_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control(
	    'shams_solar_li_font_family', array(
	    'section'  => 'shams_solar_typography',
	    'label'    => __( '"li" Tag Fonts','shams-solar'),
	    'type'     => 'select',
	    'choices'  => $font_array,
	));

	// This is H1 Color picker setting
	$wp_customize->add_setting( 'shams_solar_h1_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_h1_color', array(
		'label' => __('H1 Color', 'shams-solar'),
		'section' => 'shams_solar_typography',
		'settings' => 'shams_solar_h1_color',
	)));

	//This is H1 FontFamily picker setting
	$wp_customize->add_setting('shams_solar_h1_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control(
	    'shams_solar_h1_font_family', array(
	    'section'  => 'shams_solar_typography',
	    'label'    => __( 'H1 Fonts','shams-solar'),
	    'type'     => 'select',
	    'choices'  => $font_array,
	));

	//This is H1 FontSize setting
	$wp_customize->add_setting('shams_solar_h1_font_size',array(
		'default'	=> '50px',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_h1_font_size',array(
		'label'	=> __('H1 Font Size','shams-solar'),
		'section'	=> 'shams_solar_typography',
		'setting'	=> 'shams_solar_h1_font_size',
		'type'	=> 'text'
	));

	// This is H2 Color picker setting
	$wp_customize->add_setting( 'shams_solar_h2_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_h2_color', array(
		'label' => __('h2 Color', 'shams-solar'),
		'section' => 'shams_solar_typography',
		'settings' => 'shams_solar_h2_color',
	)));

	//This is H2 FontFamily picker setting
	$wp_customize->add_setting('shams_solar_h2_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control(
	    'shams_solar_h2_font_family', array(
	    'section'  => 'shams_solar_typography',
	    'label'    => __( 'h2 Fonts','shams-solar'),
	    'type'     => 'select',
	    'choices'  => $font_array,
	));

	//This is H2 FontSize setting
	$wp_customize->add_setting('shams_solar_h2_font_size',array(
		'default'	=> '45px',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_h2_font_size',array(
		'label'	=> __('h2 Font Size','shams-solar'),
		'section'	=> 'shams_solar_typography',
		'setting'	=> 'shams_solar_h2_font_size',
		'type'	=> 'text'
	));

	// This is H3 Color picker setting
	$wp_customize->add_setting( 'shams_solar_h3_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_h3_color', array(
		'label' => __('h3 Color', 'shams-solar'),
		'section' => 'shams_solar_typography',
		'settings' => 'shams_solar_h3_color',
	)));

	//This is H3 FontFamily picker setting
	$wp_customize->add_setting('shams_solar_h3_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control(
	    'shams_solar_h3_font_family', array(
	    'section'  => 'shams_solar_typography',
	    'label'    => __( 'h3 Fonts','shams-solar'),
	    'type'     => 'select',
	    'choices'  => $font_array,
	));

	//This is H3 FontSize setting
	$wp_customize->add_setting('shams_solar_h3_font_size',array(
		'default'	=> '36px',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_h3_font_size',array(
		'label'	=> __('h3 Font Size','shams-solar'),
		'section'	=> 'shams_solar_typography',
		'setting'	=> 'shams_solar_h3_font_size',
		'type'	=> 'text'
	));

	// This is H4 Color picker setting
	$wp_customize->add_setting( 'shams_solar_h4_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_h4_color', array(
		'label' => __('h4 Color', 'shams-solar'),
		'section' => 'shams_solar_typography',
		'settings' => 'shams_solar_h4_color',
	)));

	//This is H4 FontFamily picker setting
	$wp_customize->add_setting('shams_solar_h4_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control(
	    'shams_solar_h4_font_family', array(
	    'section'  => 'shams_solar_typography',
	    'label'    => __( 'h4 Fonts','shams-solar'),
	    'type'     => 'select',
	    'choices'  => $font_array,
	));

	//This is H4 FontSize setting
	$wp_customize->add_setting('shams_solar_h4_font_size',array(
		'default'	=> '30px',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_h4_font_size',array(
		'label'	=> __('h4 Font Size','shams-solar'),
		'section'	=> 'shams_solar_typography',
		'setting'	=> 'shams_solar_h4_font_size',
		'type'	=> 'text'
	));

	// This is H5 Color picker setting
	$wp_customize->add_setting( 'shams_solar_h5_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_h5_color', array(
		'label' => __('h5 Color', 'shams-solar'),
		'section' => 'shams_solar_typography',
		'settings' => 'shams_solar_h5_color',
	)));

	//This is H5 FontFamily picker setting
	$wp_customize->add_setting('shams_solar_h5_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control(
	    'shams_solar_h5_font_family', array(
	    'section'  => 'shams_solar_typography',
	    'label'    => __( 'h5 Fonts','shams-solar'),
	    'type'     => 'select',
	    'choices'  => $font_array,
	));

	//This is H5 FontSize setting
	$wp_customize->add_setting('shams_solar_h5_font_size',array(
		'default'	=> '25px',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_h5_font_size',array(
		'label'	=> __('h5 Font Size','shams-solar'),
		'section'	=> 'shams_solar_typography',
		'setting'	=> 'shams_solar_h5_font_size',
		'type'	=> 'text'
	));

	// This is H6 Color picker setting
	$wp_customize->add_setting( 'shams_solar_h6_color', array(
		'default' => '',
		'sanitize_callback'	=> 'sanitize_hex_color'
	));
	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_h6_color', array(
		'label' => __('h6 Color', 'shams-solar'),
		'section' => 'shams_solar_typography',
		'settings' => 'shams_solar_h6_color',
	)));

	//This is H6 FontFamily picker setting
	$wp_customize->add_setting('shams_solar_h6_font_family',array(
	  'default' => '',
	  'capability' => 'edit_theme_options',
	  'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control(
	    'shams_solar_h6_font_family', array(
	    'section'  => 'shams_solar_typography',
	    'label'    => __( 'h6 Fonts','shams-solar'),
	    'type'     => 'select',
	    'choices'  => $font_array,
	));

	//This is H6 FontSize setting
	$wp_customize->add_setting('shams_solar_h6_font_size',array(
		'default'	=> '18px',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_h6_font_size',array(
		'label'	=> __('h6 Font Size','shams-solar'),
		'section'	=> 'shams_solar_typography',
		'setting'	=> 'shams_solar_h6_font_size',
		'type'	=> 'text'
	));

	// Add the Theme Color Option section.
	$wp_customize->add_section( 'shams_solar_theme_color_option', array( 
		'panel' => 'shams_solar_panel_id', 
		'title' => esc_html__( 'Theme Color Option', 'shams-solar' ) 
	));

  	$wp_customize->add_setting( 'shams_solar_theme_color', array(
	    'default' => '#61c000',
	    'sanitize_callback' => 'sanitize_hex_color'
  	));
  	$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'shams_solar_theme_color', array(
  		'label' => __( 'Color Option', 'shams-solar' ),
	    'description' => __('One can change complete theme color on just one click.', 'shams-solar'),
	    'section' => 'shams_solar_theme_color_option',
	    'settings' => 'shams_solar_theme_color',
  	)));

  	//Layout Settings
	$wp_customize->add_section( 'shams_solar_width_layout', array(
    	'title'      => __( 'Layout Settings', 'shams-solar' ),
		'panel' => 'shams_solar_panel_id'
	) );

	$wp_customize->add_setting('shams_solar_theme_options',array(
    'default' => __('Default','shams-solar'),
        'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control('shams_solar_theme_options',array(
        'type' => 'select',
        'label' => __('Container Box','shams-solar'),
        'description' => __('Here you can change the Width layout. ','shams-solar'),
        'section' => 'shams_solar_width_layout',
        'choices' => array(
            'Default' => __('Default','shams-solar'),
            'Wide Layout' => __('Wide Layout','shams-solar'),
            'Box Layout' => __('Box Layout','shams-solar'),
        ),
	) );

	$wp_customize->add_section( 'shams_solar_general_option', array(
    	'title'      => __( 'Sidebar Settings', 'shams-solar' ),
		'panel' => 'shams_solar_panel_id'
	) );

	// Add Settings and Controls for Layout
	$wp_customize->add_setting('shams_solar_layout_settings',array(
        'default' => __('Right Sidebar','shams-solar'),
        'sanitize_callback' => 'shams_solar_sanitize_choices'	        
	));
	$wp_customize->add_control('shams_solar_layout_settings',array(
        'type' => 'radio',
        'label'     => __('Theme Sidebar Layouts', 'shams-solar'),
        'description'   => __('This option work for blog page, blog single page, archive page and search page.', 'shams-solar'),
        'section' => 'shams_solar_general_option',
        'choices' => array(
            'Left Sidebar' => __('Left Sidebar','shams-solar'),
            'Right Sidebar' => __('Right Sidebar','shams-solar'),
            'One Column' => __('Full Width','shams-solar'),
            'Grid Layout' => __('Grid Layout','shams-solar')
        ),
	));

	//Topbar section
	$wp_customize->add_section('shams_solar_contact_details',array(
		'title'	=> __('Topbar Section','shams-solar'),
		'description'	=> __('Add Header Content here','shams-solar'),
		'priority'	=> null,
		'panel' => 'shams_solar_panel_id',
	));

	//Show /Hide Topbar
	$wp_customize->add_setting( 'shams_solar_show_hide_topbar',array(
		'default' => 'true',
      	'sanitize_callback'	=> 'sanitize_text_field'
    ) );
    $wp_customize->add_control('shams_solar_show_hide_topbar',array(
    	'type' => 'checkbox',
        'label' => __( 'Show / Hide Top Header','shams-solar' ),
        'section' => 'shams_solar_contact_details'
    ));

	$wp_customize->add_setting('shams_solar_contact_number',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_contact_number',array(
		'label'	=> __('Add Phone Number','shams-solar'),
		'section'	=> 'shams_solar_contact_details',
		'setting'	=> 'shams_solar_contact_number',
		'type'		=> 'text'
	));

	$wp_customize->add_setting('shams_solar_email_address',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control('shams_solar_email_address',array(
		'label'	=> __('Add Email','shams-solar'),
		'section'	=> 'shams_solar_contact_details',
		'setting'	=> 'shams_solar_email_address',
		'type'		=> 'text'
	));

	$wp_customize->add_setting('shams_solar_time',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control('shams_solar_time',array(
		'label'	=> __('Add Time','shams-solar'),
		'section'	=> 'shams_solar_contact_details',
		'setting'	=> 'shams_solar_time',
		'type'		=> 'text'
	));

	$wp_customize->add_setting('shams_solar_facebook_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));	
	$wp_customize->add_control('shams_solar_facebook_url',array(
		'label'	=> __('Add Facebook link','shams-solar'),
		'section'	=> 'shams_solar_contact_details',
		'setting'	=> 'shams_solar_facebook_url',
		'type'	=> 'url'
	));

	$wp_customize->add_setting('shams_solar_twitter_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));	
	$wp_customize->add_control('shams_solar_twitter_url',array(
		'label'	=> __('Add Twitter link','shams-solar'),
		'section'	=> 'shams_solar_contact_details',
		'setting'	=> 'shams_solar_twitter_url',
		'type'	=> 'url'
	));
	
	$wp_customize->add_setting('shams_solar_youtube_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));	
	$wp_customize->add_control('shams_solar_youtube_url',array(
		'label'	=> __('Add Youtube link','shams-solar'),
		'section'	=> 'shams_solar_contact_details',
		'setting'	=> 'shams_solar_youtube_url',
		'type'	=> 'url'
	));

	$wp_customize->add_setting('shams_solar_google_plus_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));	
	$wp_customize->add_control('shams_solar_google_plus_url',array(
		'label'	=> __('Add Google Plus link','shams-solar'),
		'section'	=> 'shams_solar_contact_details',
		'setting'	=> 'shams_solar_google_plus_url',
		'type'	=> 'url'
	));

	$wp_customize->add_setting('shams_solar_linkedin_url',array(
		'default'	=> '',
		'sanitize_callback'	=> 'esc_url_raw'
	));
	$wp_customize->add_control('shams_solar_linkedin_url',array(
		'label'	=> __('Add Linkedin link','shams-solar'),
		'section'	=> 'shams_solar_contact_details',
		'setting'	=> 'shams_solar_linkedin_url',
		'type'	=> 'url'
	));

	//home page slider
	$wp_customize->add_section( 'shams_solar_slider' , array(
    	'title'      => __( 'Slider Settings', 'shams-solar' ),
		'priority'   => null,
		'panel' => 'shams_solar_panel_id'
	) );

	$wp_customize->add_setting('shams_solar_slider_arrows',array(
        'default' => 'true',
        'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_slider_arrows',array(
     	'type' => 'checkbox',
      	'label' => __('Show / Hide slider','shams-solar'),
      	'section' => 'shams_solar_slider',
	));

	for ( $count = 1; $count <= 4; $count++ ) {

		$wp_customize->add_setting( 'shams_solar_slide_page' . $count, array(
			'default'           => '',
			'sanitize_callback' => 'shams_solar_sanitize_dropdown_pages'
		) );

		$wp_customize->add_control( 'shams_solar_slide_page' . $count, array(
			'label'    => __( 'Select Slide Image Page', 'shams-solar' ),
			'section'  => 'shams_solar_slider',
			'type'     => 'dropdown-pages'
		) );
	}

	//content layout
    $wp_customize->add_setting('shams_solar_slider_content_option',array(
    'default' => __('Left','shams-solar'),
        'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control('shams_solar_slider_content_option',array(
        'type' => 'select',
        'label' => __('Slider Content Layout','shams-solar'),
        'section' => 'shams_solar_slider',
        'choices' => array(
            'Center' => __('Center','shams-solar'),
            'Left' => __('Left','shams-solar'),
            'Right' => __('Right','shams-solar'),
        ),
	) );

    //Slider excerpt
	$wp_customize->add_setting( 'shams_solar_slider_excerpt_number', array(
		'default'              => 20,
		'type'                 => 'theme_mod',
		'transport' 		   => 'refresh',
		'sanitize_callback'    => 'absint',
		'sanitize_js_callback' => 'absint',
	) );
	$wp_customize->add_control( 'shams_solar_slider_excerpt_number', array(
		'label'       => esc_html__( 'Slider Excerpt length','shams-solar' ),
		'section'     => 'shams_solar_slider',
		'type'        => 'range',
		'settings'    => 'shams_solar_slider_excerpt_number',
		'input_attrs' => array(
			'step'             => 2,
			'min'              => 0,
			'max'              => 50,
		),
	) );

	//Opacity
	$wp_customize->add_setting('shams_solar_slider_opacity_color',array(
      'default'              => 0.3,
      'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control( 'shams_solar_slider_opacity_color', array(
	'label'       => esc_html__( 'Slider Image Opacity','shams-solar' ),
	'section'     => 'shams_solar_slider',
	'type'        => 'select',
	'settings'    => 'shams_solar_slider_opacity_color',
	'choices' => array(
      '0' =>  esc_attr('0','shams-solar'),
      '0.1' =>  esc_attr('0.1','shams-solar'),
      '0.2' =>  esc_attr('0.2','shams-solar'),
      '0.3' =>  esc_attr('0.3','shams-solar'),
      '0.4' =>  esc_attr('0.4','shams-solar'),
      '0.5' =>  esc_attr('0.5','shams-solar'),
      '0.6' =>  esc_attr('0.6','shams-solar'),
      '0.7' =>  esc_attr('0.7','shams-solar'),
      '0.8' =>  esc_attr('0.8','shams-solar'),
      '0.9' =>  esc_attr('0.9','shams-solar')
	),
	));

	//Services Section
	$wp_customize->add_section('shams_solar_service_section',array(
		'title'	=> __('Services Section','shams-solar'),
		'description'	=> __('Add Services Section below.','shams-solar'),
		'panel' => 'shams_solar_panel_id',
	));

	$wp_customize->add_setting('shams_solar_service_section_title',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control('shams_solar_service_section_title',array(
		'label'	=> __('Section Title','shams-solar'),
		'section'	=> 'shams_solar_service_section',
		'type'		=> 'text'
	));

	$categories = get_categories();
		$cat_posts = array();
			$i = 0;
			$cat_posts[]='Select';	
		foreach($categories as $category){
			if($i==0){
			$default = $category->slug;
			$i++;
		}
		$cat_posts[$category->slug] = $category->name;
	}

	$wp_customize->add_setting('shams_solar_service_section_category',array(
		'default'	=> 'select',
		'sanitize_callback' => 'sanitize_text_field',
	));
	$wp_customize->add_control('shams_solar_service_section_category',array(
		'type'    => 'select',
		'choices' => $cat_posts,
		'label' => __('Select Category to display Latest Post','shams-solar'),
		'section' => 'shams_solar_service_section',
	));

	//Blog Post
	$wp_customize->add_section('shams_solar_blog_post',array(
		'title'	=> __('Post Settings','shams-solar'),
		'panel' => 'shams_solar_panel_id',
	));	

	$wp_customize->add_setting('shams_solar_date_hide',array(
       'default' => 'false',
       'sanitize_callback'	=> 'sanitize_text_field'
    ));
    $wp_customize->add_control('shams_solar_date_hide',array(
       'type' => 'checkbox',
       'label' => __('Post Date','shams-solar'),
       'section' => 'shams_solar_blog_post'
    ));

    $wp_customize->add_setting('shams_solar_comment_hide',array(
       'default' => 'false',
       'sanitize_callback'	=> 'sanitize_text_field'
    ));
    $wp_customize->add_control('shams_solar_comment_hide',array(
       'type' => 'checkbox',
       'label' => __('Post Comments','shams-solar'),
       'section' => 'shams_solar_blog_post'
    ));

    $wp_customize->add_setting('shams_solar_author_hide',array(
       'default' => 'false',
       'sanitize_callback'	=> 'sanitize_text_field'
    ));
    $wp_customize->add_control('shams_solar_author_hide',array(
       'type' => 'checkbox',
       'label' => __('Post Author','shams-solar'),
       'section' => 'shams_solar_blog_post'
    ));

    $wp_customize->add_setting('shams_solar_tags_hide',array(
       'default' => 'false',
       'sanitize_callback'	=> 'sanitize_text_field'
    ));
    $wp_customize->add_control('shams_solar_tags_hide',array(
       'type' => 'checkbox',
       'label' => __('Post Tags','shams-solar'),
       'section' => 'shams_solar_blog_post'
    ));

    $wp_customize->add_setting( 'shams_solar_excerpt_number', array(
		'default'              => 20,
		'type'                 => 'theme_mod',
		'transport' 		   => 'refresh',
		'sanitize_callback'    => 'absint',
		'sanitize_js_callback' => 'absint',
	) );
	$wp_customize->add_control( 'shams_solar_excerpt_number', array(
		'label'       => esc_html__( 'Excerpt length','shams-solar' ),
		'section'     => 'shams_solar_blog_post',
		'type'        => 'number',
		'settings'    => 'shams_solar_excerpt_number',
		'input_attrs' => array(
			'step'             => 2,
			'min'              => 0,
			'max'              => 50,
		),
	) );

	$wp_customize->add_setting('shams_solar_button_text',array(
		'default'=> 'READ MORE',
		'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_button_text',array(
		'label'	=> __('Add Button Text','shams-solar'),
		'section'=> 'shams_solar_blog_post',
		'type'=> 'text'
	));

	//Footer
	$wp_customize->add_section( 'shams_solar_footer' , array(
    	'title'      => __( 'Footer Section', 'shams-solar' ),
		'priority'   => null,
		'panel' => 'shams_solar_panel_id'
	) );

	$wp_customize->add_setting('shams_solar_footer_widget',array(
        'default'           => '4',
        'sanitize_callback' => 'shams_solar_sanitize_choices',
    ));
    $wp_customize->add_control('shams_solar_footer_widget',array(
        'type'        => 'radio',
        'label'       => __('No. of Footer widget area', 'shams-solar'),
        'section'     => 'shams_solar_footer',
        'description' => __('Select the number of footer widget areas and after that, go to Appearance > Widgets and add your widgets in the footer.', 'shams-solar'),
        'choices' => array(
            '1'     => __('One', 'shams-solar'),
            '2'     => __('Two', 'shams-solar'),
            '3'     => __('Three', 'shams-solar'),
            '4'     => __('Four', 'shams-solar')
        ),
    )); 

	$wp_customize->add_setting('shams_solar_hide_show_scroll',array(
        'default' => 'true',
        'sanitize_callback'	=> 'sanitize_text_field'
	));
	$wp_customize->add_control('shams_solar_hide_show_scroll',array(
     	'type' => 'checkbox',
      	'label' => __('Show / Hide Scroll To Top','shams-solar'),
      	'section' => 'shams_solar_footer',
	));

	$wp_customize->add_setting('shams_solar_footer_options',array(
        'default' => __('Right align','shams-solar'),
        'sanitize_callback' => 'shams_solar_sanitize_choices'
	));
	$wp_customize->add_control('shams_solar_footer_options',array(
        'type' => 'select',
        'label' => __('Scroll To Top','shams-solar'),
        'description' => __('Here you can change the Footer layout. ','shams-solar'),
        'section' => 'shams_solar_footer',
        'choices' => array(
            'Left align' => __('Left align','shams-solar'),
            'Right align' => __('Right align','shams-solar'),
            'Center align' => __('Center align','shams-solar'),
        ),
	) );

	$wp_customize->add_setting('shams_solar_footer_text',array(
		'default'	=> '',
		'sanitize_callback'	=> 'sanitize_text_field'
	));	
	$wp_customize->add_control('shams_solar_footer_text',array(
		'label'	=> __('Add Copyright Text','shams-solar'),
		'section'	=> 'shams_solar_footer',
		'setting'	=> 'shams_solar_footer_text',
		'type'		=> 'text'
	));

	$wp_customize->get_setting( 'blogname' )->transport          = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport   = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport  = 'postMessage';

	$wp_customize->selective_refresh->add_partial( 'blogname', array(
		'selector' => '.site-title a',
		'render_callback' => 'shams_solar_customize_partial_blogname',
	) );
	$wp_customize->selective_refresh->add_partial( 'blogdescription', array(
		'selector' => '.site-description',
		'render_callback' => 'shams_solar_customize_partial_blogdescription',
	) );
	
}
add_action( 'customize_register', 'shams_solar_customize_register' );

/**
 * Render the site title for the selective refresh partial.
 *
 * @since Shams Solar 1.0
 * @see shams-solar_customize_register()
 *
 * @return void
 */
function shams_solar_customize_partial_blogname() {
	bloginfo( 'name' );
}

/**
 * Render the site tagline for the selective refresh partial.
 *
 * @since Shams Solar 1.0
 * @see shams-solar_customize_register()
 *
 * @return void
 */
function shams_solar_customize_partial_blogdescription() {
	bloginfo( 'description' );
}

/**
 * Return whether we're on a view that supports a one or two column layout.
 */
function shams_solar_is_view_with_layout_option() {
	// This option is available on all pages. It's also available on archives when there isn't a sidebar.
	return ( is_page() || ( is_archive() && ! is_active_sidebar( 'footer-1' ) ) );
}

/**
 * Singleton class for handling the theme's customizer integration.
 *
 * @since  1.0.0
 * @access public
 */
final class Shams_Solar_Customize {

	/**
	 * Returns the instance.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return object
	 */
	public static function get_instance() {

		static $instance = null;

		if ( is_null( $instance ) ) {
			$instance = new self;
			$instance->setup_actions();
		}

		return $instance;
	}

	/**
	 * Constructor method.
	 *
	 * @since  1.0.0
	 * @access private
	 * @return void
	 */
	private function __construct() {}

	/**
	 * Sets up initial actions.
	 *
	 * @since  1.0.0
	 * @access private
	 * @return void
	 */
	private function setup_actions() {

		// Register panels, sections, settings, controls, and partials.
		add_action( 'customize_register', array( $this, 'sections' ) );

		// Register scripts and styles for the controls.
		add_action( 'customize_controls_enqueue_scripts', array( $this, 'enqueue_control_scripts' ), 0 );
	}

	/**
	 * Sets up the customizer sections.
	 *
	 * @since  1.0.0
	 * @access public
	 * @param  object  $manager
	 * @return void
	 */
	public function sections( $manager ) {

		// Load custom sections.
		load_template( trailingslashit( get_template_directory() ) . '/inc/section-pro.php' );

		// Register custom section types.
		$manager->register_section_type( 'Shams_Solar_Customize_Section_Pro' );

		// Register sections.
		$manager->add_section(
			new Shams_Solar_Customize_Section_Pro(
				$manager,
				'example_1',
				array(
					'priority' => 9,
					'title'    => esc_html__( 'Shams Solar Pro', 'shams-solar' ),
					'pro_text' => esc_html__( 'Go Pro', 'shams-solar' ),
					'pro_url'  => esc_url('https://www.themeseye.com/wordpress/solar-energy-wordpress-theme/'),
				)
			)
		);
	}

	/**
	 * Loads theme customizer CSS.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return void
	 */
	public function enqueue_control_scripts() {

		wp_enqueue_script( 'shams-solar-customize-controls', trailingslashit( get_template_directory_uri() ) . '/assets/js/customize-controls.js', array( 'customize-controls' ) );

		wp_enqueue_style( 'shams-solar-customize-controls', trailingslashit( get_template_directory_uri() ) . '/assets/css/customize-controls.css' );
	}
}

// Doing this customizer thang!
Shams_Solar_Customize::get_instance();